#pragma once
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <type_traits>
using namespace std;

// check if type is defined, forward declarations are not definitions
template <class, class = void>
struct is_defined : std::false_type {};
template <class T>
struct is_defined<
	T, std::enable_if_t<std::is_object<T>::value &&
	!std::is_pointer<T>::value && (sizeof(T) > 0)>>
	: std::true_type {};


namespace Test1 {

	template <class, class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class Toy, class Sweet, class Clothes>
	struct is_defined_method<
		Present, Toy, Sweet, Clothes,
		std::enable_if_t<
		std::is_same<decltype(Toy(std::declval<string>(), std::declval<int>())), Toy>::value&&
		std::is_same<decltype(Sweet(std::declval<string>(), std::declval<int>())), Sweet>::value&&
		std::is_same<decltype(Clothes(std::declval<string>(), std::declval<int>())), Clothes>::value&&
		std::is_same<decltype(std::declval<Present>().getName()), string>::value&&
		std::is_same<decltype(std::declval<Present>().getPrice()), int>::value&&
		std::is_same<decltype(std::declval<Present>().getType()), char>::value
		>
	> : std::true_type {};

	template <class Present, class Toy, class Sweet, class Clothes>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<Toy>::value && is_defined<Sweet>::value && is_defined<Clothes>::value && is_defined_method<Present, Toy, Sweet, Clothes>::value) {
			std::stringstream ss;

			Present* present = new Toy("doll", 350);
			ss << present->getName();
			delete present;
			present = new Sweet("candy", 95);
			ss << present->getPrice();
			delete present;
			present = new Clothes("clothes", 950);
			ss << present->getType();
			delete present;

			if (ss.str() == "doll95O") {
				std::cout << "Test passed" << std::endl;
				return 4;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test2 {

	template <class, class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class Toy, class Sweet, class Clothes>
	struct is_defined_method<
		Present, Toy, Sweet, Clothes,
		std::enable_if_t<
		std::is_same<decltype(Toy(std::declval<string>(), std::declval<int>())), Toy>::value&&
		std::is_same<decltype(Sweet(std::declval<string>(), std::declval<int>())), Sweet>::value&&
		std::is_same<decltype(Clothes(std::declval<string>(), std::declval<int>())), Clothes>::value&&
		std::is_same<decltype(std::declval<std::ostream&>() << std::declval<const Present&>()), std::ostream&>::value
		>
	> : std::true_type {};

	template <class Present, class Toy, class Sweet, class Clothes>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<Toy>::value && is_defined<Sweet>::value && is_defined<Clothes>::value && is_defined_method<Present, Toy, Sweet, Clothes>::value) {
			std::stringstream ss;

			Present* present = new Toy("toy", 250);
			ss << *present;
			delete present;
			present = new Sweet("sweet", 100);
			ss << *present;
			delete present;
			present = new Clothes("clothes", 1000);
			ss << *present;
			delete present;

			if (ss.str() == "(I) toy 250(S) sweet 100(O) clothes 1000") {
				std::cout << "Test passed" << std::endl;
				return 3;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test3 {

	template <class, class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class Toy, class Sweet, class Clothes>
	struct is_defined_method<
		Present, Toy, Sweet, Clothes,
		std::enable_if_t<
		std::is_same<decltype(Toy(std::declval<string>(), std::declval<int>())), Toy>::value&&
		std::is_same<decltype(Sweet(std::declval<string>(), std::declval<int>())), Sweet>::value&&
		std::is_same<decltype(Clothes(std::declval<string>(), std::declval<int>())), Clothes>::value&&
		std::is_same<decltype(std::declval<Present>().copy()), Present*>::value
		>
	> : std::true_type {};

	template <class Present, class Toy, class Sweet, class Clothes>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<Toy>::value && is_defined<Sweet>::value && is_defined<Clothes>::value && is_defined_method<Present, Toy, Sweet, Clothes>::value) {
			std::stringstream ss;

			Present* present = new Toy("toy", 350);
			ss << *(present->copy());
			delete present;
			present = new Sweet("candy", 100);
			ss << *(present->copy());
			delete present;
			present = new Clothes("clothes", 950);
			ss << *(present->copy());
			delete present;

			if (ss.str() == "(I) toy 350(S) candy 100(O) clothes 950") {
				std::cout << "Test passed" << std::endl;
				return 3;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test4 {

	template <class, class, class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class Toy, class Sweet, class Clothes, class Package>
	struct is_defined_method<
		Present, Toy, Sweet, Clothes, Package,
		std::enable_if_t<
		std::is_same<decltype(Toy(std::declval<string>(), std::declval<int>())), Toy>::value&&
		std::is_same<decltype(Sweet(std::declval<string>(), std::declval<int>())), Sweet>::value&&
		std::is_same<decltype(Clothes(std::declval<string>(), std::declval<int>())), Clothes>::value&&
		std::is_same<decltype(Package(std::declval<string>(), std::declval<bool>())), Package>::value&&
		std::is_same<decltype(std::declval<Package>().add(std::declval<Present*>())), void>::value&&
		std::is_same<decltype(std::declval<Package>().getPrice()), int>::value
		>
	> : std::true_type {};

	template <class Present, class Toy, class Sweet, class Clothes, class Package>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<Toy>::value && is_defined<Sweet>::value && is_defined<Clothes>::value && is_defined<Package>::value && is_defined_method<Present, Toy, Sweet, Clothes, Package>::value) {
			std::stringstream ss;

			Present* present1 = new Toy("toy", 400);
			Present* present2 = new Sweet("candy", 100);
			Present* present3 = new Clothes("clothes", 1000);

			Package package("name", false);
			package.add(present1);
			package.add(present2);
			package.add(present3);
			ss << package.getPrice();

			delete present1;
			delete present2;
			delete present3;

			if (ss.str() == "1500") {
				std::cout << "Test passed" << std::endl;
				return 4;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test5 {

	template <class, class, class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class Toy, class Sweet, class Clothes, class Package>
	struct is_defined_method<
		Present, Toy, Sweet, Clothes, Package,
		std::enable_if_t<
		std::is_same<decltype(Toy(std::declval<string>(), std::declval<int>())), Toy>::value&&
		std::is_same<decltype(Sweet(std::declval<string>(), std::declval<int>())), Sweet>::value&&
		std::is_same<decltype(Clothes(std::declval<string>(), std::declval<int>())), Clothes>::value&&
		std::is_same<decltype(Package(std::declval<string>(), std::declval<bool>())), Package>::value&&
		std::is_same<decltype(std::declval<Package>().add(std::declval<Present*>())), void>::value&&
		std::is_same<decltype(std::declval<Package>().getPrice()), int>::value
		>
	> : std::true_type {};

	template <class Present, class Toy, class Sweet, class Clothes, class Package>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<Toy>::value && is_defined<Sweet>::value && is_defined<Clothes>::value && is_defined<Package>::value && is_defined_method<Present, Toy, Sweet, Clothes, Package>::value) {
			std::stringstream ss;

			Present* present1 = new Toy("toy", 400);
			Present* present2 = new Sweet("candy", 100);
			Present* present3 = new Clothes("clothes", 1000);

			Package package("name", true);
			package.add(present1);
			package.add(present2);
			package.add(present3);
			ss << package.getPrice();

			delete present1;
			delete present2;
			delete present3;

			if (ss.str() == "1600") {
				std::cout << "Test passed" << std::endl;
				return 1;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test6 {

	template <class, class, class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class Toy, class Sweet, class Clothes, class Package>
	struct is_defined_method<
		Present, Toy, Sweet, Clothes, Package,
		std::enable_if_t<
		std::is_same<decltype(Toy(std::declval<string>(), std::declval<int>())), Toy>::value&&
		std::is_same<decltype(Sweet(std::declval<string>(), std::declval<int>())), Sweet>::value&&
		std::is_same<decltype(Clothes(std::declval<string>(), std::declval<int>())), Clothes>::value&&
		std::is_same<decltype(Package(std::declval<string>(), std::declval<bool>())), Package>::value&&
		std::is_same<decltype(std::declval<Package>().add(std::declval<Present*>())), void>::value&&
		std::is_same<decltype(std::declval<std::ostream&>() << std::declval<const Package&>()), std::ostream&>::value
		>
	> : std::true_type {};

	template <class Present, class Toy, class Sweet, class Clothes, class Package>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<Toy>::value && is_defined<Sweet>::value && is_defined<Clothes>::value && is_defined<Package>::value && is_defined_method<Present, Toy, Sweet, Clothes, Package>::value) {
			std::stringstream ss;

			Present* present1 = new Toy("toy", 400);
			Present* present2 = new Sweet("candy", 100);
			Present* present3 = new Clothes("clothes", 1000);

			Package package("street", true);
			package.add(present1);
			package.add(present2);
			package.add(present3);
			ss << package;

			delete present1;
			delete present2;
			delete present3;

			if (ss.str() == "[(I) toy 400, (S) candy 100, (O) clothes 1000]") {
				std::cout << "Test passed" << std::endl;
				return 3;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test7 {

	template <class, class, class, class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class Toy, class Sweet, class Clothes, class Package, class PresentTypeException>
	struct is_defined_method<
		Present, Toy, Sweet, Clothes, Package, PresentTypeException,
		std::enable_if_t<
		std::is_same<decltype(Toy(std::declval<string>(), std::declval<int>())), Toy>::value&&
		std::is_same<decltype(Sweet(std::declval<string>(), std::declval<int>())), Sweet>::value&&
		std::is_same<decltype(Clothes(std::declval<string>(), std::declval<int>())), Clothes>::value&&
		std::is_same<decltype(Package(std::declval<string>(), std::declval<bool>())), Package>::value&&
		std::is_same<decltype(PresentTypeException()), PresentTypeException>::value&&
		std::is_same<decltype(std::declval<Package>().add(std::declval<Present*>())), void>::value
		>
	> : std::true_type {};

	template <class Present, class Toy, class Sweet, class Clothes, class Package, class PresentTypeException>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<Toy>::value && is_defined<Sweet>::value && is_defined<Clothes>::value && is_defined<Package>::value && is_defined<PresentTypeException>::value && is_defined_method<Present, Toy, Sweet, Clothes, Package, PresentTypeException>::value) {
			std::stringstream ss;

			Present* present1 = new Toy("toy", 400);
			Present* present2 = new Sweet("candy", 100);
			Present* present3 = new Toy("another toy", 500);

			try {
				Package package("street", true);
				package.add(present1);
				package.add(present2);
				package.add(present3);
				std::cout << "Test failed" << std::endl;
				delete present1;
				delete present2;
				delete present3;
			}
			catch (const PresentTypeException& e) {
				std::cout << "Test passed" << std::endl;
				delete present1;
				delete present2;
				delete present3;
				return 2;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test8 {

	template <class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class SantaWorkshop>
	struct is_defined_method<
		Present, SantaWorkshop,
		std::enable_if_t<
		std::is_same<decltype(std::declval<std::ostream&>() << std::declval<const Present&>()), std::ostream&>::value&&
		std::is_same<decltype(SantaWorkshop(std::declval<string>())), SantaWorkshop>::value&&
		std::is_same<decltype(std::declval<SantaWorkshop>().makePresent(std::declval<string>())), Present*>::value
		>
	> : std::true_type {};

	template <class Present, class SantaWorkshop>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<SantaWorkshop>::value && is_defined_method<Present, SantaWorkshop>::value) {
			std::stringstream ss;
			std::ofstream file("input8.txt");

			file << "(I) game 700\n(S) candy 150\n(S) sweet 75\n(O) clothes 1500\n(I) toy 150\n";
			file.close();

			SantaWorkshop workshop("input8.txt");
			Present* present = workshop.makePresent("sweet");
			ss << *present;

			delete present;

			if (ss.str() == "(S) sweet 75") {
				std::cout << "Test passed" << std::endl;
				return 5;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test9 {

	template <class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Present, class SantaWorkshop, class OutOfStockException>
	struct is_defined_method<
		Present, SantaWorkshop, OutOfStockException,
		std::enable_if_t<
		std::is_same<decltype(SantaWorkshop(std::declval<string>())), SantaWorkshop>::value&&
		std::is_same<decltype(OutOfStockException()), OutOfStockException>::value&&
		std::is_same<decltype(std::declval<SantaWorkshop>().makePresent(std::declval<string>())), Present*>::value
		>
	> : std::true_type {};

	template <class Present, class SantaWorkshop, class OutOfStockException>
	int tst() {
		if constexpr (is_defined<Present>::value && is_defined<SantaWorkshop>::value && is_defined<OutOfStockException>::value && is_defined_method<Present, SantaWorkshop, OutOfStockException>::value) {
			std::stringstream ss;
			std::ofstream file("input9.txt");

			file << "(I) game 700\n(S) candy 150\n(S) sweet 75\n(O) clothes 1500\n(I) toy 150\n";
			file.close();
			
			SantaWorkshop workshop("input9.txt");
			Present* present = nullptr;
			try {
				present = workshop.makePresent("random");
				std::cout << "Test failed" << std::endl;
				delete present;
			}
			catch (const OutOfStockException& e) {
				std::cout << "Test passed" << std::endl;
				delete present;
				return 2;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test10 {

	template <class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Package, class SantaWorkshop, class SantaPostOffice>
	struct is_defined_method<
		Package, SantaWorkshop, SantaPostOffice,
		std::enable_if_t<
		std::is_same<decltype(SantaWorkshop(std::declval<string>())), SantaWorkshop>::value&&
		std::is_same<decltype(SantaPostOffice(std::declval<SantaWorkshop>())), SantaPostOffice>::value&&
		std::is_same<decltype(std::declval<SantaPostOffice>().makePackage(std::declval<string>())), Package*>::value&&
		std::is_same<decltype(std::declval<Package>().getPrice()), int>::value
		>
	> : std::true_type {};

	template <class Package, class SantaWorkshop, class SantaPostOffice>
	int tst() {
		if constexpr (is_defined<Package>::value && is_defined<SantaWorkshop>::value && is_defined<SantaPostOffice>::value && is_defined_method<Package, SantaWorkshop, SantaPostOffice>::value) {
			std::stringstream ss;

			std::ofstream fileA("input10a.txt");
			std::ofstream fileB("input10b.txt");

			fileA << "(I) game 650\n(S) candy 200\n(S) sweet 100\n(O) clothes 2000\n(I) toy 125\n";
			fileA.close();
			SantaWorkshop workshop("input10a.txt");

			SantaPostOffice office(workshop);
			
			fileB << "adresa\ncandy\nclothes\n";
			fileB.close();
			Package* package = office.makePackage("input10b.txt");
			ss << package->getPrice();
			delete package;

			if (ss.str() == "2200") {
				std::cout << "Test passed" << std::endl;
				return 5;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test11 {

	template <class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Package, class SantaWorkshop, class SantaPostOffice>
	struct is_defined_method<
		Package, SantaWorkshop, SantaPostOffice,
		std::enable_if_t<
		std::is_same<decltype(SantaWorkshop(std::declval<string>())), SantaWorkshop>::value&&
		std::is_same<decltype(SantaPostOffice(std::declval<SantaWorkshop>())), SantaPostOffice>::value&&
		std::is_same<decltype(std::declval<SantaPostOffice>().makePackage(std::declval<string>())), Package*>::value&&
		std::is_same<decltype(std::declval<Package>().getPrice()), int>::value
		>
	> : std::true_type {};

	template <class Package, class SantaWorkshop, class SantaPostOffice>
	int tst() {
		if constexpr (is_defined<Package>::value && is_defined<SantaWorkshop>::value && is_defined<SantaPostOffice>::value && is_defined_method<Package, SantaWorkshop, SantaPostOffice>::value) {
			std::stringstream ss;

			std::ofstream fileA("input11a.txt");
			std::ofstream fileB("input11b.txt");

			fileA << "(I) game 650\n(S) candy 200\n(S) sweet 100\n(O) clothes 2000\n(I) toy 125\n";
			fileA.close();
			SantaWorkshop workshop("input11a.txt");

			SantaPostOffice office(workshop);

			fileB << "adresa za dostavu\ncandy\ngame\ncandy\nclothes\n";
			fileB.close();
			Package* package = office.makePackage("input11b.txt");
			ss << package->getPrice();
			delete package;

			if (ss.str() == "2850") {
				std::cout << "Test passed" << std::endl;
				return 1;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test12 {

	template <class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Package, class SantaWorkshop, class SantaPostOffice>
	struct is_defined_method<
		Package, SantaWorkshop, SantaPostOffice,
		std::enable_if_t<
		std::is_same<decltype(SantaWorkshop(std::declval<string>())), SantaWorkshop>::value&&
		std::is_same<decltype(SantaPostOffice(std::declval<SantaWorkshop>())), SantaPostOffice>::value&&
		std::is_same<decltype(std::declval<SantaPostOffice>().makePackage(std::declval<string>())), Package*>::value&&
		std::is_same<decltype(std::declval<Package>().getPrice()), int>::value
		>
	> : std::true_type {};

	template <class Package, class SantaWorkshop, class SantaPostOffice>
	int tst() {
		if constexpr (is_defined<Package>::value && is_defined<SantaWorkshop>::value && is_defined<SantaPostOffice>::value && is_defined_method<Package, SantaWorkshop, SantaPostOffice>::value) {
			std::stringstream ss;

			std::ofstream fileA("input12a.txt");
			std::ofstream fileB("input12b.txt");

			fileA << "(I) game 650\n(S) candy 200\n(S) sweet 100\n(O) clothes 2000\n(I) toy 125\n";
			fileA.close();
			SantaWorkshop workshop("input12a.txt");

			SantaPostOffice office(workshop);

			fileB << "adresa za dostavu\ncandy\ntoy\nsweet\ngame\nclothes\n";
			fileB.close();
			Package* package = office.makePackage("input12b.txt");
			ss << package->getPrice();
			delete package;

			if (ss.str() == "2325") {
				std::cout << "Test passed" << std::endl;
				return 1;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}

namespace Test13 {

	template <class, class, class, class = void>
	struct is_defined_method : std::false_type {};

	template <class Package, class SantaWorkshop, class SantaPostOffice>
	struct is_defined_method<
		Package, SantaWorkshop, SantaPostOffice,
		std::enable_if_t<
		std::is_same<decltype(SantaWorkshop(std::declval<string>())), SantaWorkshop>::value&&
		std::is_same<decltype(SantaPostOffice(std::declval<SantaWorkshop>())), SantaPostOffice>::value&&
		std::is_same<decltype(std::declval<SantaPostOffice>().makePackage(std::declval<string>())), Package*>::value&&
		std::is_same<decltype(std::declval<Package>().getPrice()), int>::value
		>
	> : std::true_type {};

	template <class Package, class SantaWorkshop, class SantaPostOffice>
	int tst() {
		if constexpr (is_defined<Package>::value && is_defined<SantaWorkshop>::value && is_defined<SantaPostOffice>::value && is_defined_method<Package, SantaWorkshop, SantaPostOffice>::value) {
			std::stringstream ss;

			std::ofstream fileA("input13a.txt");
			std::ofstream fileB("input13b.txt");

			fileA << "(I) game 650\n(S) candy 200\n(S) sweet 100\n(O) clothes 2000\n(I) toy 125\n";
			fileA.close();
			SantaWorkshop workshop("input13a.txt");

			SantaPostOffice office(workshop);

			fileB << "PRIORITY\nadresa za dostavu\nsweet\nball\ntoy\n";
			fileB.close();
			Package* package = office.makePackage("input13b.txt");
			ss << package->getPrice();
			delete package;

			if (ss.str() == "425") {
				std::cout << "Test passed" << std::endl;
				return 1;
			}
			else {
				std::cout << "Test failed" << std::endl;
			}
		}
		else {
			std::cout << "Interface failed" << std::endl;
		}
		return 0;
	}
}